#!/usr/bin/env macruby

framework 'AppKit'
class AppDelegate
  def applicationDidFinishLaunching(notification)
    voice_type = "com.apple.speech.synthesis.voice.Whisper"
    @voice = NSSpeechSynthesizer.alloc.initWithVoice(voice_type)
  end

  def windowWillClose(notification)
    puts "Bye!"
    exit
  end

  def say_stuff(sender)
    @voice.startSpeakingString("Listen closely... Ruby is available right on top of Objective C and Cocoa!")
  end
end

app = NSApplication.sharedApplication
app.delegate = AppDelegate.new

window = NSWindow.alloc.initWithContentRect([200, 600, 300, 100],
   styleMask:NSTitledWindowMask|NSClosableWindowMask|NSMiniaturizableWindowMask,
   backing:NSBackingStoreBuffered,
   defer:false)
    
now = Time.now
window.title      = "Opened at #{now}"
window.level      = NSModalPanelWindowLevel
window.delegate   = app.delegate

button = NSButton.alloc.initWithFrame([80, 10, 120, 80])
button.bezelStyle = 8
button.title      = 'Psst!'
button.target     = app.delegate
button.action     = 'say_stuff:'

window.contentView.addSubview(button)

window.display
window.orderFrontRegardless
app.run